<?php

namespace Shop\Models\OrderSign\Base;

use \Exception;
use \PDO;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;
use Shop\Models\Order\Order;
use Shop\Models\OrderSign\OrderSign as ChildOrderSign;
use Shop\Models\OrderSign\OrderSignQuery as ChildOrderSignQuery;
use Shop\Models\OrderSign\Map\OrderSignTableMap;

/**
 * Base class that represents a query for the 'shop_order_signs' table.
 *
 *
 *
 * @method     ChildOrderSignQuery orderByMoyskladSync($order = Criteria::ASC) Order by the moysklad_sync column
 * @method     ChildOrderSignQuery orderByBitrixSync($order = Criteria::ASC) Order by the bitrix_sync column
 * @method     ChildOrderSignQuery orderById($order = Criteria::ASC) Order by the id column
 *
 * @method     ChildOrderSignQuery groupByMoyskladSync() Group by the moysklad_sync column
 * @method     ChildOrderSignQuery groupByBitrixSync() Group by the bitrix_sync column
 * @method     ChildOrderSignQuery groupById() Group by the id column
 *
 * @method     ChildOrderSignQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildOrderSignQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildOrderSignQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildOrderSignQuery leftJoinWith($relation) Adds a LEFT JOIN clause and with to the query
 * @method     ChildOrderSignQuery rightJoinWith($relation) Adds a RIGHT JOIN clause and with to the query
 * @method     ChildOrderSignQuery innerJoinWith($relation) Adds a INNER JOIN clause and with to the query
 *
 * @method     ChildOrderSignQuery leftJoinOrder($relationAlias = null) Adds a LEFT JOIN clause to the query using the Order relation
 * @method     ChildOrderSignQuery rightJoinOrder($relationAlias = null) Adds a RIGHT JOIN clause to the query using the Order relation
 * @method     ChildOrderSignQuery innerJoinOrder($relationAlias = null) Adds a INNER JOIN clause to the query using the Order relation
 *
 * @method     ChildOrderSignQuery joinWithOrder($joinType = Criteria::INNER_JOIN) Adds a join clause and with to the query using the Order relation
 *
 * @method     ChildOrderSignQuery leftJoinWithOrder() Adds a LEFT JOIN clause and with to the query using the Order relation
 * @method     ChildOrderSignQuery rightJoinWithOrder() Adds a RIGHT JOIN clause and with to the query using the Order relation
 * @method     ChildOrderSignQuery innerJoinWithOrder() Adds a INNER JOIN clause and with to the query using the Order relation
 *
 * @method     \Shop\Models\Order\OrderQuery endUse() Finalizes a secondary criteria and merges it with its primary Criteria
 *
 * @method     ChildOrderSign findOne(ConnectionInterface $con = null) Return the first ChildOrderSign matching the query
 * @method     ChildOrderSign findOneOrCreate(ConnectionInterface $con = null) Return the first ChildOrderSign matching the query, or a new ChildOrderSign object populated from the query conditions when no match is found
 *
 * @method     ChildOrderSign findOneByMoyskladSync(string $moysklad_sync) Return the first ChildOrderSign filtered by the moysklad_sync column
 * @method     ChildOrderSign findOneByBitrixSync(string $bitrix_sync) Return the first ChildOrderSign filtered by the bitrix_sync column
 * @method     ChildOrderSign findOneById(int $id) Return the first ChildOrderSign filtered by the id column *

 * @method     ChildOrderSign requirePk($key, ConnectionInterface $con = null) Return the ChildOrderSign by primary key and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildOrderSign requireOne(ConnectionInterface $con = null) Return the first ChildOrderSign matching the query and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildOrderSign requireOneByMoyskladSync(string $moysklad_sync) Return the first ChildOrderSign filtered by the moysklad_sync column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildOrderSign requireOneByBitrixSync(string $bitrix_sync) Return the first ChildOrderSign filtered by the bitrix_sync column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildOrderSign requireOneById(int $id) Return the first ChildOrderSign filtered by the id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildOrderSign[]|ObjectCollection find(ConnectionInterface $con = null) Return ChildOrderSign objects based on current ModelCriteria
 * @method     ChildOrderSign[]|ObjectCollection findByMoyskladSync(string $moysklad_sync) Return ChildOrderSign objects filtered by the moysklad_sync column
 * @method     ChildOrderSign[]|ObjectCollection findByBitrixSync(string $bitrix_sync) Return ChildOrderSign objects filtered by the bitrix_sync column
 * @method     ChildOrderSign[]|ObjectCollection findById(int $id) Return ChildOrderSign objects filtered by the id column
 * @method     ChildOrderSign[]|\Propel\Runtime\Util\PropelModelPager paginate($page = 1, $maxPerPage = 10, ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 *
 */
abstract class OrderSignQuery extends ModelCriteria
{
    protected $entityNotFoundExceptionClass = '\\Propel\\Runtime\\Exception\\EntityNotFoundException';

    /**
     * Initializes internal state of \Shop\Models\OrderSign\Base\OrderSignQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'default', $modelName = '\\Shop\\Models\\OrderSign\\OrderSign', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildOrderSignQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildOrderSignQuery
     */
    public static function create($modelAlias = null, Criteria $criteria = null)
    {
        if ($criteria instanceof ChildOrderSignQuery) {
            return $criteria;
        }
        $query = new ChildOrderSignQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildOrderSign|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, ConnectionInterface $con = null)
    {
        if ($key === null) {
            return null;
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(OrderSignTableMap::DATABASE_NAME);
        }

        $this->basePreSelect($con);

        if (
            $this->formatter || $this->modelAlias || $this->with || $this->select
            || $this->selectColumns || $this->asColumns || $this->selectModifiers
            || $this->map || $this->having || $this->joins
        ) {
            return $this->findPkComplex($key, $con);
        }

        if ((null !== ($obj = OrderSignTableMap::getInstanceFromPool(null === $key || is_scalar($key) || is_callable([$key, '__toString']) ? (string) $key : $key)))) {
            // the object is already in the instance pool
            return $obj;
        }

        return $this->findPkSimple($key, $con);
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildOrderSign A model object, or null if the key is not found
     */
    protected function findPkSimple($key, ConnectionInterface $con)
    {
        $sql = 'SELECT `moysklad_sync`, `bitrix_sync`, `id` FROM `shop_order_signs` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            /** @var ChildOrderSign $obj */
            $obj = new ChildOrderSign();
            $obj->hydrate($row);
            OrderSignTableMap::addInstanceToPool($obj, null === $key || is_scalar($key) || is_callable([$key, '__toString']) ? (string) $key : $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildOrderSign|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, ConnectionInterface $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(OrderSignTableMap::COL_ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(OrderSignTableMap::COL_ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the moysklad_sync column
     *
     * Example usage:
     * <code>
     * $query->filterByMoyskladSync('fooValue');   // WHERE moysklad_sync = 'fooValue'
     * $query->filterByMoyskladSync('%fooValue%', Criteria::LIKE); // WHERE moysklad_sync LIKE '%fooValue%'
     * </code>
     *
     * @param     string $moyskladSync The value to use as filter.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function filterByMoyskladSync($moyskladSync = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($moyskladSync)) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(OrderSignTableMap::COL_MOYSKLAD_SYNC, $moyskladSync, $comparison);
    }

    /**
     * Filter the query on the bitrix_sync column
     *
     * Example usage:
     * <code>
     * $query->filterByBitrixSync('fooValue');   // WHERE bitrix_sync = 'fooValue'
     * $query->filterByBitrixSync('%fooValue%', Criteria::LIKE); // WHERE bitrix_sync LIKE '%fooValue%'
     * </code>
     *
     * @param     string $bitrixSync The value to use as filter.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function filterByBitrixSync($bitrixSync = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($bitrixSync)) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(OrderSignTableMap::COL_BITRIX_SYNC, $bitrixSync, $comparison);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @see       filterByOrder()
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(OrderSignTableMap::COL_ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(OrderSignTableMap::COL_ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(OrderSignTableMap::COL_ID, $id, $comparison);
    }

    /**
     * Filter the query by a related \Shop\Models\Order\Order object
     *
     * @param \Shop\Models\Order\Order|ObjectCollection $order The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildOrderSignQuery The current query, for fluid interface
     */
    public function filterByOrder($order, $comparison = null)
    {
        if ($order instanceof \Shop\Models\Order\Order) {
            return $this
                ->addUsingAlias(OrderSignTableMap::COL_ID, $order->getId(), $comparison);
        } elseif ($order instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(OrderSignTableMap::COL_ID, $order->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByOrder() only accepts arguments of type \Shop\Models\Order\Order or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the Order relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function joinOrder($relationAlias = null, $joinType = 'LEFT JOIN')
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('Order');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'Order');
        }

        return $this;
    }

    /**
     * Use the Order relation Order object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Shop\Models\Order\OrderQuery A secondary query class using the current class as primary query
     */
    public function useOrderQuery($relationAlias = null, $joinType = 'LEFT JOIN')
    {
        return $this
            ->joinOrder($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'Order', '\Shop\Models\Order\OrderQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ChildOrderSign $orderSign Object to remove from the list of results
     *
     * @return $this|ChildOrderSignQuery The current query, for fluid interface
     */
    public function prune($orderSign = null)
    {
        if ($orderSign) {
            $this->addUsingAlias(OrderSignTableMap::COL_ID, $orderSign->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the shop_order_signs table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(OrderSignTableMap::DATABASE_NAME);
        }

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con) {
            $affectedRows = 0; // initialize var to track total num of affected rows
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            OrderSignTableMap::clearInstancePool();
            OrderSignTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

    /**
     * Performs a DELETE on the database based on the current ModelCriteria
     *
     * @param ConnectionInterface $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public function delete(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(OrderSignTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(OrderSignTableMap::DATABASE_NAME);

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con, $criteria) {
            $affectedRows = 0; // initialize var to track total num of affected rows

            OrderSignTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            OrderSignTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

} // OrderSignQuery
